(******************************************************)
(*                                                    *)
(*            EldoS SecureBlackbox Library            *)
(*                                                    *)
(*      Copyright (c) 2002-2006 EldoS Corporation     *)
(*           http://www.secureblackbox.com            *)
(*                                                    *)
(******************************************************)

unit SBRTCClientPlugin;

{$ifdef CLR}
    {$DEFINE DELPHI_NET}
    {$DEFINE NET_registered}
{$endif}

{$ifndef CLR}
{$ifndef FPC}
{$define DELPHI_WIN}
{$endif}
{$endif}

{$IFDEF VER120}
  {$DEFINE D_3_UP}
  {$DEFINE D_4_UP}
  {$DEFINE VCL40}
{$ENDIF}

{$IFDEF VER125}
  {$DEFINE B_3_UP}
  {$DEFINE B_4_UP}
  {$DEFINE B_4}
  {$DEFINE VCL40}
  {$DEFINE BUILDER_USED}
{$ENDIF}

{$IFDEF VER130}
	{$IFDEF BCB}
		{$DEFINE B_3_UP}
		{$DEFINE B_4_UP}
		{$DEFINE B_5_UP}
		{$DEFINE B_5}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
		{$DEFINE BUILDER_USED}
    {$ELSE}
		{$DEFINE D_3_UP}
		{$DEFINE D_4_UP}
		{$DEFINE D_5_UP}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
    {$ENDIF}
{$ENDIF}

{$IFDEF VER140}
	{$IFDEF BCB}
		{$DEFINE B_3_UP}
		{$DEFINE B_4_UP}
		{$DEFINE B_5_UP}
		{$DEFINE B_6_UP}
		{$DEFINE B_6}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
		{$DEFINE VCL60}
		{$DEFINE BUILDER_USED}
    {$ELSE}
		{$DEFINE D_3_UP}
		{$DEFINE D_4_UP}
		{$DEFINE D_5_UP}
		{$DEFINE D_6_UP}
		{$DEFINE D_6}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
		{$DEFINE VCL60}
		{.DEFINE USEADO}
    {$ENDIF}
{$ENDIF}


{$IFDEF VER150}
	{$IFNDEF BCB}
		{$DEFINE D_3_UP}
		{$DEFINE D_4_UP}
		{$DEFINE D_5_UP}
		{$DEFINE D_6_UP}
		{$DEFINE D_7_UP}
		{$DEFINE D_7}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
		{$DEFINE VCL60}
		{$DEFINE VCL70}
		{.DEFINE USEADO}
    {$ENDIF}
{$ENDIF}

{$IFDEF VER160}
    {$DEFINE D_3_UP}
    {$DEFINE D_4_UP}
    {$DEFINE D_5_UP}
    {$DEFINE D_6_UP}
    {$DEFINE D_7_UP}
    {$DEFINE D_8_UP}
    {$DEFINE D_8}
    {$DEFINE VCL40}
    {$DEFINE VCL50}
    {$DEFINE VCL60}
    {$DEFINE VCL70}
    {$DEFINE VCL80}
    {.$DEFINE USE_NAME_SPACE} // Optional !!!
{$ENDIF}

{$IFDEF VER170}
    {$DEFINE D_3_UP}
    {$DEFINE D_4_UP}
    {$DEFINE D_5_UP}
    {$DEFINE D_6_UP}
    {$DEFINE D_7_UP}
    {$DEFINE D_8_UP}
    {$DEFINE D_9_UP}
    {$DEFINE D_9}
    {$DEFINE VCL40}
    {$DEFINE VCL50}
    {$DEFINE VCL60}
    {$DEFINE VCL70}
    {$DEFINE VCL80}
    {$DEFINE VCL90}
    {.$DEFINE USE_NAME_SPACE} // Optional !!!
{$ENDIF}

{$IFDEF VER180}
    {$DEFINE D_3_UP}
    {$DEFINE D_4_UP}
    {$DEFINE D_5_UP}
    {$DEFINE D_6_UP}
    {$DEFINE D_7_UP}
    {$DEFINE D_8_UP}
    {$DEFINE D_9_UP}
    {$DEFINE D_X_UP}
    {$DEFINE D_X}
    {$DEFINE VCL40}
    {$DEFINE VCL50}
    {$DEFINE VCL60}
    {$DEFINE VCL70}
    {$DEFINE VCL80}
    {$DEFINE VCL90}
    {$DEFINE VCL100}

    {$DEFINE B_3_UP}
    {$DEFINE B_4_UP}
    {$DEFINE B_5_UP}
    {$DEFINE B_6_UP}
    {$DEFINE B_X_UP}
    {$DEFINE B_X}
    {$ifndef DELPHI_NET}
    {$DEFINE BUILDER_USED}
    {$endif}
{$ENDIF}

{$ifndef CHROME}
{$ifndef DELPHI_NET}
{$IFDEF D_7_UP}
{$WARN UNSAFE_CODE OFF}
{$WARN UNSAFE_TYPE OFF}
{$WARN UNSAFE_CAST OFF}
{$ENDIF}
{$ENDIF}
{$ENDIF}

interface

uses
  Classes,
  SysUtils,
  rtcPlugins,
  SBUtils,
  SBRTCPlugin,
  SBSSLCommon,
  SBSSLConstants,
  SBConstants,
  SBClient,
  SBX509,
  SBCustomCertStorage;

type

  TSSLClientRtcHandler = class(TSSLRtcHandler)
  protected
    FOnCertificateChoose: TSBChooseCertificateEvent;
    FOnCertificateNeededEx: TSBCertificateNeededExEvent;
    FOnKeyNeeded: TSBClientKeyNeededEvent;
    FSecureClient : TElSecureClient;

    procedure HandleKeyNeeded(Sender: TObject; const Hint : string;  var Identity : string; var Key : ByteArray);
    procedure HandleCloseConnection(Sender: TObject; CloseReason: TSBCloseReason);
    procedure HandleCertificateChoose(Sender: TObject;
      {$ifdef BUILDER_USED}Certificates: TList;{$else}Certificates: array of TElX509Certificate; {$endif}
      var CertificateIndex: Integer);
    procedure HandleCertificateNeededEx(Sender : TObject; var Certificate : TElX509Certificate);

    function GetCertStorage: TElCustomCertStorage;
    function GetCipherSuite: TSBCipherSuite; override;
    function GetCipherSuites(Index: TSBCipherSuite): boolean;
    function GetCompressionAlgorithm: TSBSSLCompressionAlgorithm; override;
    function GetCompressionAlgorithms(Index: TSBSSLCompressionAlgorithm): boolean;
    function GetExtensions: TElClientSSLExtensions;
    function GetPeerExtensions: TElCustomSSLExtensions;
    function GetVersion: TSBVersion; override;
    function GetVersions: TSBVersions;
    procedure HandleOpenConnection(Sender: TObject); override;
    procedure SetCertStorage(const Value: TElCustomCertStorage);
    procedure SetCipherSuites(Index: TSBCipherSuite; Value: boolean);
    procedure SetCompressionAlgorithms(Index: TSBSSLCompressionAlgorithm; Value:
        boolean);
    procedure SetVersions(Value: TSBVersions);
  public
    constructor Create; override;
    destructor Destroy; override;
    { Called after a new connection was established.
      OutData = data which has to be sent out immediately. }
    procedure AfterConnect(var OutData: string);
    { Called after a connection was closed. }
    procedure AfterDisconnect;
    { Called before we do a graceful disconnect, in case some data has to be sent out. }
    procedure BeforeDisconnect(var OutData: string);
    procedure Close;
    { Called when data arrived.
      InData = data received from recipient (decode that!)
      OutData = data prepared by "decoder" for sending back to recipient (encoded data)
      OutPlainText = decrypted input data (for use by application) }
    procedure DataReceived(const InData: string; var OutData, OutPlainText: string);
    { Called when data needs to be sent.
      InData = application data which we want to be encoded for sending
      OutData = encoded data which should be sent out }
    procedure DataToSend(const InData: string; var OutData: string);
    procedure InternalValidate(var Validity: TSBCertificateValidity; var Reason:
        TSBCertificateValidityReason);
    procedure Open;
    property CipherSuite: TSBCipherSuite read GetCipherSuite;
    property CipherSuites[Index: TSBCipherSuite]: boolean read GetCipherSuites
        write SetCipherSuites;
    property CompressionAlgorithm: TSBSSLCompressionAlgorithm read
        GetCompressionAlgorithm;
    property CompressionAlgorithms[Index: TSBSSLCompressionAlgorithm]: boolean read
        GetCompressionAlgorithms write SetCompressionAlgorithms;
    property Extensions: TElClientSSLExtensions read GetExtensions;
    property PeerExtensions: TElCustomSSLExtensions read GetPeerExtensions;
    property Version: TSBVersion read GetVersion;
  published
    property CertStorage: TElCustomCertStorage read GetCertStorage write
        SetCertStorage;
    property Versions: TSBVersions read GetVersions write SetVersions;
    property OnCertificateChoose: TSBChooseCertificateEvent read
        FOnCertificateChoose write FOnCertificateChoose;
    property OnCertificateNeededEx: TSBCertificateNeededExEvent read
        FOnCertificateNeededEx write FOnCertificateNeededEx;
    property OnKeyNeeded: TSBClientKeyNeededEvent read FOnKeyNeeded write
        FOnKeyNeeded;
  end;

  TSSLClientRtcCryptPlugin = class(TSSLRtcCryptPlugin)
  private
    FCertStorage: TElCustomCertStorage;
    FExtensions: TElClientSSLExtensions;
    FOnCertificateChoose: TSBChooseCertificateEvent;
    FOnCertificateNeededEx: TSBCertificateNeededExEvent;
    FOnKeyNeeded: TSBClientKeyNeededEvent;
    function CreateHandler(ConnID : TRtcConnID): TSSLClientRtcHandler;
    function FindHandler(ConnID : TRtcConnID): TSSLClientRtcHandler;
  protected
    function GetCertStorage: TElCustomCertStorage;
    procedure HandleCertificateChoose(Sender: TObject;
        {$ifdef BUILDER_USED}Certificates: TList;{$else}Certificates: array of
        TElX509Certificate; {$endif} var CertificateIndex: Integer);
    procedure HandleCertificateNeededEx(Sender : TObject; var Certificate :
        TElX509Certificate);
    procedure HandleKeyNeeded(Sender: TObject; const Hint : string; var Identity :
        string; var Key : ByteArray);
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure SetCertStorage(const Value: TElCustomCertStorage);
  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
    { Called after a new connection was established.
      OutData = data which has to be sent out immediately. }
    procedure AfterConnect(ID:TRtcConnID; var OutData:string); override;
    { Called after a connection was closed. }
    procedure AfterDisconnect(ID:TRtcConnID); override;
    { Called before we do a graceful disconnect, in case some data has to be sent out. }
    procedure BeforeDisconnect(ID:TRtcConnID; var OutData:string); override;
    { Called when data arrived.
      InData = data received from recipient (decode that!)
      OutData = data prepared by "decoder" for sending back to recipient (encoded data)
      OutPlainText = decrypted input data (for use by application) }
    procedure DataReceived(ID:TRtcConnID; const InData:string; var OutData:string;
        var OutPlainText:string); override;
    { Called when data needs to be sent.
      InData = application data which we want to be encoded for sending
      OutData = encoded data which should be sent out }
    procedure DataToSend(ID:TRtcConnID; const InData:string; var OutData:string);
        override;
    property Extensions: TElClientSSLExtensions read FExtensions;
  published
    property CertStorage: TElCustomCertStorage read GetCertStorage write
        SetCertStorage;
    property OnCertificateChoose: TSBChooseCertificateEvent read
        FOnCertificateChoose write FOnCertificateChoose;
    property OnCertificateNeededEx: TSBCertificateNeededExEvent read
        FOnCertificateNeededEx write FOnCertificateNeededEx;
    property OnKeyNeeded: TSBClientKeyNeededEvent read FOnKeyNeeded write
        FOnKeyNeeded;
  end;

procedure Register;

implementation

{ TSSLClientRtcCryptPlugin }

procedure Register;
begin
  RegisterComponents('SSLBlackbox', [TSSLClientRtcCryptPlugin]);
end;

{ TSSLClientRtcHandler }

constructor TSSLClientRtcHandler.Create;
begin
  inherited;
  FSecureClient := TElSecureClient.Create(nil);
  FSecureClient.OnSend := HandleSend;
  FSecureClient.OnReceive := HandleReceive;
  FSecureClient.OnData := HandleData;
  FSecureClient.OnOpenConnection := HandleOpenConnection;
  FSecureClient.OnCloseConnection := HandleCloseConnection;
  FSecureClient.OnCertificateValidate := HandleCertificateValidate;
  FSecureClient.OnCertificateChoose := HandleCertificateChoose;
  FSecureClient.OnCertificateNeededEx := HandleCertificateNeededEx;
  FSecureClient.OnCiphersNegotiated := HandleCiphersNegotiated;
  FSecureClient.OnKeyNeeded := HandleKeyNeeded;
  FSecureClient.OnError := HandleError;
end;

destructor TSSLClientRtcHandler.Destroy;
begin
  inherited;
  FreeAndNil(FSecureClient);
end;

{ TSSLServerRtcCryptPlugin }

procedure TSSLClientRtcHandler.AfterConnect(var OutData: string);
begin
  FSecureClient.Open;
  if Length(FOutBuffer) > 0 then
  begin
    SetLength(OutData, Length(FOutBuffer));
    Move(FOutBuffer[0], OutData[1], Length(FOutBuffer));
    SetLength(FOutBuffer, 0);
  end;
end;

procedure TSSLClientRtcHandler.AfterDisconnect;
begin
end;

procedure TSSLClientRtcHandler.BeforeDisconnect(var OutData: string);
begin
  FSecureClient.Close;
  //Close;
  if Length(FOutBuffer) > 0 then
  begin
    SetLength(OutData, Length(FOutBuffer));
    Move(FOutBuffer[0], OutData[1], Length(FOutBuffer));
    SetLength(FOutBuffer, 0);
  end;
end;

procedure TSSLClientRtcHandler.Close;
var b : boolean;
begin
  b := FSecureClient.Enabled;
  FSecureClient.Enabled := false;
  FSecureClient.Close;
  FSecureClient.Enabled := b;
end;

procedure TSSLClientRtcHandler.DataReceived(const InData: string; var OutData,
    OutPlainText: string);
var OldSize : integer;
begin
  OutData := '';
  OutPlainText := '';

  if Length(InData) > 0 then
  begin
    // put incoming data
    OldSize := Length(FInBuffer);
    SetLength(FInBuffer, OldSize + Length(InData));
    Move(InData[1], FInBuffer[OldSize], Length(InData));

    // process the data
    while Length(FInBuffer) > 0 do
      FSecureClient.DataAvailable;
  end;

  // pick resulting data
  if Length(FOutBuffer) > 0 then
  begin
    SetLength(OutData, Length(FOutBuffer));
    Move(FOutBuffer[0], OutData[1], Length(FOutBuffer));
    SetLength(FOutBuffer, 0);
  end;

  // pick resulting data
  if Length(FDataBuffer) > 0 then
  begin
    SetLength(OutPlainText, Length(FDataBuffer));
    Move(FDataBuffer[0], OutPlainText[1], Length(FDataBuffer));
    SetLength(FDataBuffer, 0);
  end;

end;

procedure TSSLClientRtcHandler.DataToSend(const InData: string; var OutData:
    string);
begin
  OutData := '';

  if InData <> '' then
    FSecureClient.SendData(@InData[1], Length(InData));

  if Length(FOutBuffer) > 0 then
  begin
    SetLength(OutData, Length(FOutBuffer));
    Move(FOutBuffer[0], OutData[1], Length(FOutBuffer));
    SetLength(FOutBuffer, 0);
  end;
end;

function TSSLClientRtcHandler.GetCertStorage: TElCustomCertStorage;
begin
  Result := FSecureClient.CertStorage;
end;

function TSSLClientRtcHandler.GetCipherSuite: TSBCipherSuite;
begin
  Result := FSecureClient.CipherSuite;
end;

function TSSLClientRtcHandler.GetCipherSuites(Index: TSBCipherSuite): boolean;
begin
  Result := FSecureClient.CipherSuites[Index];
end;

function TSSLClientRtcHandler.GetCompressionAlgorithm:
    TSBSSLCompressionAlgorithm;
begin
  Result := FSecureClient.CompressionAlgorithm;
end;

function TSSLClientRtcHandler.GetCompressionAlgorithms(Index:
    TSBSSLCompressionAlgorithm): boolean;
begin
  Result := FSecureClient.CompressionAlgorithms[Index];
end;

function TSSLClientRtcHandler.GetExtensions: TElClientSSLExtensions;
begin
  Result := FSecureClient.Extensions;
end;

function TSSLClientRtcHandler.GetPeerExtensions: TElCustomSSLExtensions;
begin
  Result := FSecureClient.PeerExtensions;
end;

function TSSLClientRtcHandler.GetVersion: TSBVersion;
begin
  Result := FSecureClient.CurrentVersion;
end;

function TSSLClientRtcHandler.GetVersions: TSBVersions;
begin
  Result := FSecureClient.Versions;
end;

procedure TSSLClientRtcHandler.InternalValidate(var Validity:
    TSBCertificateValidity; var Reason: TSBCertificateValidityReason);
begin
  FSecureClient.InternalValidate(Validity, Reason);
end;

procedure TSSLClientRtcHandler.Open;
begin
  inherited;
end;

procedure TSSLClientRtcHandler.SetCertStorage(const Value:
    TElCustomCertStorage);
begin
  FSecureClient.CertStorage := Value;
end;

procedure TSSLClientRtcHandler.SetCipherSuites(Index: TSBCipherSuite; Value:
    boolean);
begin
  FSecureClient.CipherSuites[Index] := Value;
end;

procedure TSSLClientRtcHandler.SetCompressionAlgorithms(Index:
    TSBSSLCompressionAlgorithm; Value: boolean);
begin
  FSecureClient.CompressionAlgorithms[Index] := Value;
end;

procedure TSSLClientRtcHandler.SetVersions(Value: TSBVersions);
begin
  FSecureClient.Versions := Value;
end;

constructor TSSLClientRtcCryptPlugin.Create(AOwner: TComponent);
begin
  inherited;

  FExtensions := TElClientSSLExtensions.Create;
end;

destructor TSSLClientRtcCryptPlugin.Destroy;
begin
  CertStorage := nil;
  FreeAndNil(FExtensions);
  FListGuard.Enter;
  try
    while FConnList.Count > 0 do
    begin
      TSSLClientRtcHandler(FConnList.Last).Free;
      FConnList.Delete(FConnList.Count - 1);
    end;
  finally
    FListGuard.Leave;
  end;
  inherited;
end;

{ TSSLServerRtcCryptPlugin }

procedure TSSLClientRtcCryptPlugin.AfterConnect(ID: TRtcConnID; var OutData:
    string);
var Handler : TSSLClientRtcHandler;
begin
  Handler := CreateHandler(ID);
  Handler.AfterConnect(OutData);
end;

procedure TSSLClientRtcCryptPlugin.AfterDisconnect(ID: TRtcConnID);
var Handler : TSSLClientRtcHandler;
begin
  Handler := FindHandler(ID);
  if Handler <> nil then
  begin
    FListGuard.Enter;
    Self.FConnList.Remove(Handler);
    FListGuard.Leave;
    Handler.AfterDisconnect;
    Handler.Free;
  end;
end;

procedure TSSLClientRtcCryptPlugin.BeforeDisconnect(ID: TRtcConnID; var
    OutData: string);
var Handler : TSSLClientRtcHandler;
begin
  Handler := FindHandler(ID);
  if Handler <> nil then
  begin
    Handler.BeforeDisconnect(OutData);
  end;
end;

function TSSLClientRtcCryptPlugin.CreateHandler(ConnID : TRtcConnID):
    TSSLClientRtcHandler;
var i : integer;
begin
  Result := TSSLClientRtcHandler.Create;
  Result.FConnID := ConnID;
  FListGuard.Enter;
  FConnList.Add(Result);
  FListGuard.Leave;

  Result.CertStorage := FCertStorage;
  for I := SB_SUITE_FIRST to SB_SUITE_LAST do
    Result.CipherSuites[I] := FEnabledCipherSuites[I];
  for I := SSL_CA_FIRST to SSL_CA_LAST do
    Result.CompressionAlgorithms[I] := FCompressionAlgorithms[I];
  Result.Versions := FVersions;

  Result.OnCertificateValidate := HandleCertificateValidate;
  Result.OnSSLEstablished := HandleSSLEstablished;
  Result.OnCiphersNegotiated := HandleCiphersNegotiated;
  Result.OnError := HandleError;
  Result.OnExtensionsReceived := HandleExtensionsReceived;

  Result.OnCertificateNeededEx := HandleCertificateNeededEx;
  Result.OnCertificateChoose := HandleCertificateChoose;
  Result.OnKeyNeeded := HandleKeyNeeded;

  Result.Extensions.Assign(Extensions);
  Result.PeerExtensions.Assign(PeerExtensions);

  Result.OnError := HandleError;
  Result.Open;
end;

procedure TSSLClientRtcCryptPlugin.DataReceived(ID: TRtcConnID; const InData:
    string; var OutData, OutPlainText: string);
var Handler : TSSLClientRtcHandler;
begin
  Handler := FindHandler(ID);
  if Handler <> nil then
  begin
    Handler.DataReceived(InData, OutData, OutPlainText);
  end;
end;

procedure TSSLClientRtcCryptPlugin.DataToSend(ID: TRtcConnID; const InData:
    string; var OutData: string);
var Handler : TSSLClientRtcHandler;
begin
  Handler := FindHandler(ID);
  if Handler <> nil then
  begin
    Handler.DataToSend(InData, OutData);
  end;
end;

function TSSLClientRtcCryptPlugin.FindHandler(ConnID: TRtcConnID):
    TSSLClientRtcHandler;
var i : integer;
begin
  result := nil;
  FListGuard.Enter;
  try
    for i := 0 to FConnList.Count - 1 do
    begin
      if TSSLClientRtcHandler(FConnList[i]).FConnID = ConnID then
      begin
        result := TSSLClientRtcHandler(FConnList[i]);
        exit;
      end;
    end;
  finally
    FListGuard.Leave;
  end;
end;

function TSSLClientRtcCryptPlugin.GetCertStorage: TElCustomCertStorage;
begin
  Result := FCertStorage;
end;

procedure TSSLClientRtcCryptPlugin.HandleCertificateChoose(Sender: TObject;
    {$ifdef BUILDER_USED}Certificates: TList;{$else}Certificates: array of
    TElX509Certificate; {$endif} var CertificateIndex: Integer);
begin
  CertificateIndex := 0;
  
  if assigned(FOnCertificateChoose) then
    FOnCertificateChoose(Sender, Certificates, CertificateIndex); 
end;

procedure TSSLClientRtcCryptPlugin.HandleCertificateNeededEx(Sender: TObject;
    var Certificate: TElX509Certificate);
begin
  if assigned(FOnCertificateNeededEx) then
    FOnCertificateNeededEx(Self, Certificate);
end;

procedure TSSLClientRtcCryptPlugin.HandleKeyNeeded(Sender: TObject; const Hint:
    string; var Identity: string; var Key: ByteArray);
begin
  if assigned(FOnKeyNeeded) then
    FOnKeyNeeded(Self, Hint, Identity, Key);
end;

procedure TSSLClientRtcCryptPlugin.Notification(AComponent: TComponent;
    Operation: TOperation);
begin
  inherited;
  if Operation = opRemove then
  begin
    if (AComponent = CertStorage) then
    begin
      SetCertStorage(nil);
    end;
  end;
end;

procedure TSSLClientRtcCryptPlugin.SetCertStorage(const Value:
    TElCustomCertStorage);
begin
  if Value <> FCertStorage then
  begin
    FCertStorage := Value;
    if Value <> nil then
      Value.FreeNotification(Self);
  end;
end;

procedure TSSLClientRtcHandler.HandleCertificateChoose(Sender: TObject;
      {$ifdef BUILDER_USED}Certificates: TList;{$else}Certificates: array of TElX509Certificate; {$endif}
      var CertificateIndex: Integer);
begin
  CertificateIndex := 0;
  
  if assigned(FOnCertificateChoose) then
    FOnCertificateChoose(Sender, Certificates, CertificateIndex); 
end;

procedure TSSLClientRtcHandler.HandleCloseConnection(Sender: TObject;
    CloseReason: TSBCloseReason);
begin
  FConnected := false;
end;

procedure TSSLClientRtcHandler.HandleCertificateNeededEx(Sender: TObject;
  var Certificate: TElX509Certificate);
begin
  if assigned(FOnCertificateNeededEx) then
    FOnCertificateNeededEx(Self, Certificate);
end;

procedure TSSLClientRtcHandler.HandleKeyNeeded(Sender: TObject;
  const Hint: string; var Identity: string; var Key: ByteArray);
begin
  if assigned(FOnKeyNeeded) then
    FOnKeyNeeded(Self, Hint, Identity, Key);
end;

procedure TSSLClientRtcHandler.HandleOpenConnection(Sender: TObject);
begin
  inherited;
  HandleSSLEstablished(Self, FSecureClient.CurrentVersion, FSecureClient.CipherSuite);
end;

end.
 
