(******************************************************)
(*                                                    *)
(*            EldoS SecureBlackbox Library            *)
(*                                                    *)
(*      Copyright (c) 2002-2006 EldoS Corporation     *)
(*           http://www.secureblackbox.com            *)
(*                                                    *)
(******************************************************)

unit SBRTCPlugin;

interface

{$ifdef CLR}
    {$DEFINE DELPHI_NET}
    {$DEFINE NET_registered}
{$endif}

{$ifndef CLR}
{$ifndef FPC}
{$define DELPHI_WIN}
{$endif}
{$endif}

{$IFDEF VER120}
  {$DEFINE D_3_UP}
  {$DEFINE D_4_UP}
  {$DEFINE VCL40}
{$ENDIF}

{$IFDEF VER125}
  {$DEFINE B_3_UP}
  {$DEFINE B_4_UP}
  {$DEFINE B_4}
  {$DEFINE VCL40}
  {$DEFINE BUILDER_USED}
{$ENDIF}

{$IFDEF VER130}
	{$IFDEF BCB}
		{$DEFINE B_3_UP}
		{$DEFINE B_4_UP}
		{$DEFINE B_5_UP}
		{$DEFINE B_5}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
		{$DEFINE BUILDER_USED}
    {$ELSE}
		{$DEFINE D_3_UP}
		{$DEFINE D_4_UP}
		{$DEFINE D_5_UP}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
    {$ENDIF}
{$ENDIF}

{$IFDEF VER140}
	{$IFDEF BCB}
		{$DEFINE B_3_UP}
		{$DEFINE B_4_UP}
		{$DEFINE B_5_UP}
		{$DEFINE B_6_UP}
		{$DEFINE B_6}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
		{$DEFINE VCL60}
		{$DEFINE BUILDER_USED}
    {$ELSE}
		{$DEFINE D_3_UP}
		{$DEFINE D_4_UP}
		{$DEFINE D_5_UP}
		{$DEFINE D_6_UP}
		{$DEFINE D_6}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
		{$DEFINE VCL60}
		{.DEFINE USEADO}
    {$ENDIF}
{$ENDIF}


{$IFDEF VER150}
	{$IFNDEF BCB}
		{$DEFINE D_3_UP}
		{$DEFINE D_4_UP}
		{$DEFINE D_5_UP}
		{$DEFINE D_6_UP}
		{$DEFINE D_7_UP}
		{$DEFINE D_7}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
		{$DEFINE VCL60}
		{$DEFINE VCL70}
		{.DEFINE USEADO}
    {$ENDIF}
{$ENDIF}

{$IFDEF VER160}
    {$DEFINE D_3_UP}
    {$DEFINE D_4_UP}
    {$DEFINE D_5_UP}
    {$DEFINE D_6_UP}
    {$DEFINE D_7_UP}
    {$DEFINE D_8_UP}
    {$DEFINE D_8}
    {$DEFINE VCL40}
    {$DEFINE VCL50}
    {$DEFINE VCL60}
    {$DEFINE VCL70}
    {$DEFINE VCL80}
    {.$DEFINE USE_NAME_SPACE} // Optional !!!
{$ENDIF}

{$IFDEF VER170}
    {$DEFINE D_3_UP}
    {$DEFINE D_4_UP}
    {$DEFINE D_5_UP}
    {$DEFINE D_6_UP}
    {$DEFINE D_7_UP}
    {$DEFINE D_8_UP}
    {$DEFINE D_9_UP}
    {$DEFINE D_9}
    {$DEFINE VCL40}
    {$DEFINE VCL50}
    {$DEFINE VCL60}
    {$DEFINE VCL70}
    {$DEFINE VCL80}
    {$DEFINE VCL90}
    {.$DEFINE USE_NAME_SPACE} // Optional !!!
{$ENDIF}

{$IFDEF VER180}
    {$DEFINE D_3_UP}
    {$DEFINE D_4_UP}
    {$DEFINE D_5_UP}
    {$DEFINE D_6_UP}
    {$DEFINE D_7_UP}
    {$DEFINE D_8_UP}
    {$DEFINE D_9_UP}
    {$DEFINE D_X_UP}
    {$DEFINE D_X}
    {$DEFINE VCL40}
    {$DEFINE VCL50}
    {$DEFINE VCL60}
    {$DEFINE VCL70}
    {$DEFINE VCL80}
    {$DEFINE VCL90}
    {$DEFINE VCL100}

    {$DEFINE B_3_UP}
    {$DEFINE B_4_UP}
    {$DEFINE B_5_UP}
    {$DEFINE B_6_UP}
    {$DEFINE B_X_UP}
    {$DEFINE B_X}
    {$ifndef DELPHI_NET}
    {$DEFINE BUILDER_USED}
    {$endif}
{$ENDIF}

{$ifndef CHROME}
{$ifndef DELPHI_NET}
{$IFDEF D_7_UP}
{$WARN UNSAFE_CODE OFF}
{$WARN UNSAFE_TYPE OFF}
{$WARN UNSAFE_CAST OFF}
{$ENDIF}
{$ENDIF}
{$ENDIF}

uses
  Classes,
  SysUtils,
  SyncObjs,
  rtcPlugins,
  SBX509,
  SBConstants,
  SBSSLCommon,
  SBSSLConstants,
  SBCustomCertStorage,
  SBUtils
;

type

  TSSLRtcHandler = class;
  
  ERTCSBBSSLException = class(ESecureBlackboxError);

  TSBRtcPluginCertificateValidateEvent = procedure(Sender: TObject;
    X509Certificate: TElX509Certificate; Handler: TSSLRtcHandler;
    var Validate: boolean) of object;

  TSBSSLEstablishedEvent = procedure(Sender : TObject; Version : TSBVersion; CipherSuite : TSBCipherSuite) of object;

  TSSLRtcHandler = class
  protected
    FConnID: TRtcConnID;
    FConnected: boolean;
    FInBuffer  : ByteArray;
    FOutBuffer : ByteArray;
    FDataBuffer: ByteArray;
    FDataReceived: boolean;
    FErrorOccured: boolean;

    FOnCertificateValidate: TSBRtcPluginCertificateValidateEvent;
    FOnCiphersNegotiated: TNotifyEvent;
    FOnError: TSBErrorEvent;
    FOnExtensionsReceived: TSBExtensionsReceivedEvent;
    FOnSSLEstablished: TSBSSLEstablishedEvent;

    function GetCipherSuite: TSBCipherSuite; virtual; abstract;
    function GetCompressionAlgorithm: TSBSSLCompressionAlgorithm; virtual; abstract;
    function GetVersion: TSBVersion; virtual; abstract;

    procedure HandleExtensionsReceived(Sender : TObject);
    procedure HandleSSLEstablished(Sender : TObject; Version : TSBVersion;
        CipherSuite : TSBCipherSuite); 
    procedure HandleCertificateValidate(Sender: TObject; X509Certificate:
        TElX509Certificate; var Validate: boolean);
    procedure HandleCiphersNegotiated(Sender : TObject);

    procedure HandleData(Sender: TObject; Buffer: pointer; Size: longint);
    procedure HandleError(Sender : TObject; ErrorCode: integer; Fatal: boolean;
        Remote : boolean);
    procedure HandleOpenConnection(Sender: TObject); virtual; 
    procedure HandleReceive(Sender: TObject; Buffer: pointer; MaxSize: longint;
        {$ifndef BUIlDER_USED}out{$else}var{$endif} Written: longint);
    procedure HandleSend(Sender: TObject; Buffer: pointer; Size: longint);
  public
    constructor Create; virtual;
    property CipherSuite: TSBCipherSuite read GetCipherSuite;
    property CompressionAlgorithm: TSBSSLCompressionAlgorithm read
        GetCompressionAlgorithm;
    property ConnID: TRtcConnID read FConnID write FConnID;
    property Version: TSBVersion read GetVersion;

    property OnCertificateValidate: TSBRtcPluginCertificateValidateEvent read
        FOnCertificateValidate write FOnCertificateValidate;
    property OnCiphersNegotiated: TNotifyEvent read FOnCiphersNegotiated write
        FOnCiphersNegotiated;
    property OnError: TSBErrorEvent read FOnError write FOnError;
    property OnExtensionsReceived: TSBExtensionsReceivedEvent read
        FOnExtensionsReceived write FOnExtensionsReceived;
    property OnSSLEstablished: TSBSSLEstablishedEvent read FOnSSLEstablished write
        FOnSSLEstablished;
  end;

  TSSLRtcCryptPlugin = class(TRtcCryptPlugin)
  protected
    FConnList : TList;
    FListGuard : TCriticalSection;

    FOnCertificateValidate: TSBRtcPluginCertificateValidateEvent;
    FOnSSLEstablished : TSBSSLEstablishedEvent;
    FVersions: TSBVersions;
    FEnabledCipherSuites: array[SB_SUITE_FIRST..SB_SUITE_LAST] of boolean;
    FCompressionAlgorithms : array[TSBSSLCompressionAlgorithm] of boolean;
    FForceCertificateChain : boolean;
    FPeerExtensions: TElCustomSSLExtensions;
    FOnCiphersNegotiated: TNotifyEvent;
    FOnError: TSBErrorEvent;
    FOnExtensionsReceived: TSBExtensionsReceivedEvent;

    procedure HandleCertificateValidate(Sender: TObject; X509Certificate:
        TElX509Certificate; Handler: TSSLRtcHandler; var Validate: boolean);
    procedure HandleCiphersNegotiated(Sender : TObject);
    procedure HandleError(Sender : TObject; ErrorCode: integer; Fatal: boolean;
        Remote : boolean);
    procedure HandleExtensionsReceived(Sender : TObject);
    procedure HandleSSLEstablished(Sender : TObject; Version : TSBVersion;
        CipherSuite : TSBCipherSuite);

    function GetCompressionAlgorithms(Index: TSBSSLCompressionAlgorithm): boolean;
    procedure SetCompressionAlgorithms(Index: TSBSSLCompressionAlgorithm; Value:
        boolean);
    function GetCipherSuites(Index: TSBCipherSuite): boolean;
    procedure SetCipherSuites(Index: TSBCipherSuite; Value: boolean);
  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
    property CipherSuites[Index: TSBCipherSuite]: boolean read GetCipherSuites
        write SetCipherSuites;
    property CompressionAlgorithms[Index: TSBSSLCompressionAlgorithm]: boolean read
        GetCompressionAlgorithms write SetCompressionAlgorithms;
    property PeerExtensions: TElCustomSSLExtensions read FPeerExtensions;
  published
    property Versions: TSBVersions read FVersions write FVersions;
    
    property OnCertificateValidate: TSBRtcPluginCertificateValidateEvent
      read FOnCertificateValidate write FOnCertificateValidate;
    property OnCiphersNegotiated: TNotifyEvent read FOnCiphersNegotiated write
        FOnCiphersNegotiated;
    property OnError: TSBErrorEvent read FOnError write FOnError;
    property OnExtensionsReceived: TSBExtensionsReceivedEvent read
        FOnExtensionsReceived write FOnExtensionsReceived;
    property OnSSLEstablished : TSBSSLEstablishedEvent read
      FOnSSLEstablished write FOnSSLEstablished;
  end;

implementation

{ TSSLServerRtcHandler }

constructor TSSLRtcHandler.Create;
begin
  FConnected := false;
  FErrorOccured := false;
end;

procedure TSSLRtcHandler.HandleCertificateValidate(Sender: TObject;
    X509Certificate: TElX509Certificate; var Validate: boolean);
begin
  if Assigned(FOnCertificateValidate) then
    FOnCertificateValidate(Self, X509Certificate, Self, Validate);
end;

procedure TSSLRtcHandler.HandleCiphersNegotiated(Sender : TObject);
begin
  if Assigned(FOnCiphersNegotiated) then
    FOnCiphersNegotiated(Self);
end;

procedure TSSLRtcHandler.HandleData(Sender: TObject; Buffer: pointer; Size:
    longint);
var OldSize : integer;
begin
  if Size = 0 then
  begin
    FDataReceived := false;
    exit;
  end;
  OldSize := Length(FDataBuffer);
  SetLength(FDataBuffer, OldSize + Size);
  Move(Buffer^, FDataBuffer[OldSize], Size);
  FDataReceived := True;
end;

procedure TSSLRtcHandler.HandleError(Sender : TObject; ErrorCode: integer;
    Fatal: boolean; Remote : boolean);
begin
  if Assigned(FOnError) then
    FOnError(Self, ErrorCode, Fatal, Remote);
  raise ERTCSBBSSLException.Create('SSL error occured', ErrorCode);
end;

procedure TSSLRtcHandler.HandleExtensionsReceived(Sender : TObject);
begin
  if assigned(FOnExtensionsReceived) then
    FOnExtensionsReceived(Self);
end;

procedure TSSLRtcHandler.HandleOpenConnection(Sender: TObject);
begin
  FConnected := true;
end;

procedure TSSLRtcHandler.HandleReceive(Sender: TObject; Buffer: pointer;
    MaxSize: longint; {$ifndef BUIlDER_USED}out{$else}var{$endif} Written:
    longint);
begin
  Written := Min(Length(FInBuffer), MaxSize);
  Move(FInBuffer[0], Buffer^, Written);
  if Written < Length(FInBuffer) then
  begin
    Move(FInBuffer[Written], FInBuffer[0], Length(FInBuffer) - Written);
    SetLength(FInBuffer, Length(FInBuffer) - Written);
  end
  else
    SetLength(FInBuffer, 0);
end;

procedure TSSLRtcHandler.HandleSend(Sender: TObject; Buffer: pointer; Size:
    longint);
var OldSize : integer;
begin
  if Size > 0 then
  begin
    OldSize := Length(FOutBuffer);
    SetLength(FOutBuffer, OldSize + Size);
    Move(Buffer^, FOutBuffer[OldSize], Size);
  end;
end;

procedure TSSLRtcHandler.HandleSSLEstablished(Sender: TObject; Version:
    TSBVersion; CipherSuite: TSBCipherSuite);
begin
  if assigned(FOnSSLEstablished) then
    FOnSSLEstablished(Self, Version, CipherSuite);
end;

constructor TSSLRtcCryptPlugin.Create(AOwner: TComponent);
var I : integer;
begin
  inherited;
  FListGuard := TCriticalSection.Create;
  FConnList := TList.Create;
  FVersions := [sbSSL3, SBTLS1];
  for I := SB_SUITE_RSA_RC4_MD5 to SB_SUITE_LAST do
    FEnabledCipherSuites[I] := True;

  FCompressionAlgorithms[SSL_CA_NONE] := true;
  FCompressionAlgorithms[SSL_CA_ZLIB] := false;

  FPeerExtensions := TElCustomSSLExtensions.Create;
end;

destructor TSSLRtcCryptPlugin.Destroy;
begin
  FreeAndNil(FPeerExtensions);
  FListGuard.Enter;
  FreeAndNil(FConnList);
  inherited;
  FListGuard.Leave;
  FreeAndNil(FListGuard);
end;

function TSSLRtcCryptPlugin.GetCompressionAlgorithms(Index:
    TSBSSLCompressionAlgorithm): boolean;
begin
  Result := FCompressionAlgorithms[Index];
end;

procedure TSSLRtcCryptPlugin.SetCompressionAlgorithms(Index:
    TSBSSLCompressionAlgorithm; Value: boolean);
begin
  FCompressionAlgorithms[Index] := Value;
end;

function TSSLRtcCryptPlugin.GetCipherSuites(Index: TSBCipherSuite):
    boolean;
begin
  Result := FEnabledCipherSuites[Index];
end;

procedure TSSLRtcCryptPlugin.HandleCertificateValidate(Sender: TObject;
    X509Certificate: TElX509Certificate; Handler: TSSLRtcHandler; var Validate:
    boolean);
begin
  if Assigned(FOnCertificateValidate) then
    FOnCertificateValidate(Self, X509Certificate, Handler, Validate);
end;

procedure TSSLRtcCryptPlugin.HandleCiphersNegotiated(Sender : TObject);
begin
  if Assigned(FOnCiphersNegotiated) then
    FOnCiphersNegotiated(Self);
end;

procedure TSSLRtcCryptPlugin.HandleError(Sender : TObject; ErrorCode: integer;
    Fatal: boolean; Remote : boolean);
begin
  if Assigned(FOnError) then
    FOnError(Self, ErrorCode, Fatal, Remote);
end;

procedure TSSLRtcCryptPlugin.HandleExtensionsReceived(Sender : TObject);
begin
  if assigned(FOnExtensionsReceived) then
    FOnExtensionsReceived(Self);
end;

procedure TSSLRtcCryptPlugin.HandleSSLEstablished(Sender: TObject; Version:
    TSBVersion; CipherSuite: TSBCipherSuite);
begin
  if assigned(FOnSSLEstablished) then
    FOnSSLEstablished(Self, Version, CipherSuite);
end;

procedure TSSLRtcCryptPlugin.SetCipherSuites(Index: TSBCipherSuite;
    Value: boolean);
begin
  FEnabledCipherSuites[Index] := Value;
end;


end.
 
