(******************************************************)
(*                                                    *)
(*            EldoS SecureBlackbox Library            *)
(*                                                    *)
(*      Copyright (c) 2002-2006 EldoS Corporation     *)
(*           http://www.secureblackbox.com            *)
(*                                                    *)
(******************************************************)

unit SBRTCServerPlugin;

{$ifdef CLR}
    {$DEFINE DELPHI_NET}
    {$DEFINE NET_registered}
{$endif}

{$ifndef CLR}
{$ifndef FPC}
{$define DELPHI_WIN}
{$endif}
{$endif}

{$IFDEF VER120}
  {$DEFINE D_3_UP}
  {$DEFINE D_4_UP}
  {$DEFINE VCL40}
{$ENDIF}

{$IFDEF VER125}
  {$DEFINE B_3_UP}
  {$DEFINE B_4_UP}
  {$DEFINE B_4}
  {$DEFINE VCL40}
  {$DEFINE BUILDER_USED}
{$ENDIF}

{$IFDEF VER130}
	{$IFDEF BCB}
		{$DEFINE B_3_UP}
		{$DEFINE B_4_UP}
		{$DEFINE B_5_UP}
		{$DEFINE B_5}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
		{$DEFINE BUILDER_USED}
    {$ELSE}
		{$DEFINE D_3_UP}
		{$DEFINE D_4_UP}
		{$DEFINE D_5_UP}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
    {$ENDIF}
{$ENDIF}

{$IFDEF VER140}
	{$IFDEF BCB}
		{$DEFINE B_3_UP}
		{$DEFINE B_4_UP}
		{$DEFINE B_5_UP}
		{$DEFINE B_6_UP}
		{$DEFINE B_6}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
		{$DEFINE VCL60}
		{$DEFINE BUILDER_USED}
    {$ELSE}
		{$DEFINE D_3_UP}
		{$DEFINE D_4_UP}
		{$DEFINE D_5_UP}
		{$DEFINE D_6_UP}
		{$DEFINE D_6}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
		{$DEFINE VCL60}
		{.DEFINE USEADO}
    {$ENDIF}
{$ENDIF}


{$IFDEF VER150}
	{$IFNDEF BCB}
		{$DEFINE D_3_UP}
		{$DEFINE D_4_UP}
		{$DEFINE D_5_UP}
		{$DEFINE D_6_UP}
		{$DEFINE D_7_UP}
		{$DEFINE D_7}
		{$DEFINE VCL40}
		{$DEFINE VCL50}
		{$DEFINE VCL60}
		{$DEFINE VCL70}
		{.DEFINE USEADO}
    {$ENDIF}
{$ENDIF}

{$IFDEF VER160}
    {$DEFINE D_3_UP}
    {$DEFINE D_4_UP}
    {$DEFINE D_5_UP}
    {$DEFINE D_6_UP}
    {$DEFINE D_7_UP}
    {$DEFINE D_8_UP}
    {$DEFINE D_8}
    {$DEFINE VCL40}
    {$DEFINE VCL50}
    {$DEFINE VCL60}
    {$DEFINE VCL70}
    {$DEFINE VCL80}
    {.$DEFINE USE_NAME_SPACE} // Optional !!!
{$ENDIF}

{$IFDEF VER170}
    {$DEFINE D_3_UP}
    {$DEFINE D_4_UP}
    {$DEFINE D_5_UP}
    {$DEFINE D_6_UP}
    {$DEFINE D_7_UP}
    {$DEFINE D_8_UP}
    {$DEFINE D_9_UP}
    {$DEFINE D_9}
    {$DEFINE VCL40}
    {$DEFINE VCL50}
    {$DEFINE VCL60}
    {$DEFINE VCL70}
    {$DEFINE VCL80}
    {$DEFINE VCL90}
    {.$DEFINE USE_NAME_SPACE} // Optional !!!
{$ENDIF}

{$IFDEF VER180}
    {$DEFINE D_3_UP}
    {$DEFINE D_4_UP}
    {$DEFINE D_5_UP}
    {$DEFINE D_6_UP}
    {$DEFINE D_7_UP}
    {$DEFINE D_8_UP}
    {$DEFINE D_9_UP}
    {$DEFINE D_X_UP}
    {$DEFINE D_X}
    {$DEFINE VCL40}
    {$DEFINE VCL50}
    {$DEFINE VCL60}
    {$DEFINE VCL70}
    {$DEFINE VCL80}
    {$DEFINE VCL90}
    {$DEFINE VCL100}

    {$DEFINE B_3_UP}
    {$DEFINE B_4_UP}
    {$DEFINE B_5_UP}
    {$DEFINE B_6_UP}
    {$DEFINE B_X_UP}
    {$DEFINE B_X}
    {$ifndef DELPHI_NET}	    
    {$DEFINE BUILDER_USED}
    {$endif}
{$ENDIF}
    
{$ifndef CHROME}
{$ifndef DELPHI_NET}
{$IFDEF D_7_UP}
{$WARN UNSAFE_CODE OFF}
{$WARN UNSAFE_TYPE OFF}
{$WARN UNSAFE_CAST OFF}
{$ENDIF}
{$ENDIF}
{$ENDIF}


interface

uses
  Classes,
  SysUtils,

  rtcPlugins,
  SBRTCPlugin,

  SBConstants,
  SBServer,
  SBSSLCommon,
  SBSSLConstants,
  SBCustomCertStorage,
  SBSessionPool,
  SBUtils,
  SBX509
  ;

type

  TSSLServerRtcHandler = class;
  TSSLServerRtcCryptPlugin = class;

  TSSLServerRtcHandler = class(TSSLRtcHandler)
  protected
    FSecureServer : TElSecureServer;

    FOnCertificateURLs: TSBCertificateURLsEvent;
    FOnKeyNeeded: TSBServerKeyNeededEvent;

    function GetAuthenticationLevel: TSBAuthenticationLevel;
    function GetCertStorage: TElMemoryCertStorage;
    function GetCipherSuite: TSBCipherSuite; override;
    function GetCipherSuites(Index: TSBCipherSuite): boolean;
    function GetClientAuthentication: boolean;
    function GetClientCertStorage: TElCustomCertStorage;
    function GetCompressionAlgorithm: TSBSSLCompressionAlgorithm; override;
    function GetCompressionAlgorithms(Index: TSBSSLCompressionAlgorithm): boolean;
    function GetExtensions: TElServerSSLExtensions;
    function GetForceCertificateChain: boolean;
    function GetPeerExtensions: TElCustomSSLExtensions;
    function GetSessionPool: TElSessionPool;
    function GetVersion: TSBVersion; override;
    function GetVersions: TSBVersions;
    procedure HandleCloseConnection(Sender: TObject; CloseDescription: integer);
    procedure HandleOpenConnection(Sender: TObject); override;
    procedure SetAuthenticationLevel(Value: TSBAuthenticationLevel);
    procedure SetCertStorage(Value: TElMemoryCertStorage);
    procedure SetCipherSuites(Index: TSBCipherSuite; Value: boolean);
    procedure SetClientAuthentication(Value: boolean);
    procedure SetClientCertStorage(Value: TElCustomCertStorage);
    procedure SetCompressionAlgorithms(Index: TSBSSLCompressionAlgorithm; Value:
        boolean);
    procedure SetForceCertificateChain(Value : boolean);
    procedure SetSessionPool(Value: TElSessionPool);
    procedure SetVersions(Value: TSBVersions);
  public
    constructor Create; override;
    destructor Destroy; override;
    { Called after a new connection was established.
      OutData = data which has to be sent out immediately. }
    procedure AfterConnect(var OutData: string);
    { Called after a connection was closed. }
    procedure AfterDisconnect;
    { Called before we do a graceful disconnect, in case some data has to be sent out. }
    procedure BeforeDisconnect(var OutData: string);
    procedure Close;
    { Called when data arrived.
      InData = data received from recipient (decode that!)
      OutData = data prepared by "decoder" for sending back to recipient (encoded data)
      OutPlainText = decrypted input data (for use by application) }
    procedure DataReceived(const InData: string; var OutData, OutPlainText:
        string);
    { Called when data needs to be sent.
      InData = application data which we want to be encoded for sending
      OutData = encoded data which should be sent out }
    procedure DataToSend(const InData: string; var OutData: string);
    procedure InternalValidate(var Validity: TSBCertificateValidity; var Reason:
        TSBCertificateValidityReason);
    procedure Open;

    property CipherSuite: TSBCipherSuite read GetCipherSuite;

    property CompressionAlgorithm: TSBSSLCompressionAlgorithm read
        GetCompressionAlgorithm;
    property Version: TSBVersion read GetVersion;

    property CompressionAlgorithms[Index: TSBSSLCompressionAlgorithm]: boolean read
        GetCompressionAlgorithms write SetCompressionAlgorithms;
    property CipherSuites[Index: TSBCipherSuite]: boolean read GetCipherSuites
        write SetCipherSuites;

    property Extensions: TElServerSSLExtensions read GetExtensions;
    property PeerExtensions: TElCustomSSLExtensions read GetPeerExtensions;
  published

    property AuthenticationLevel: TSBAuthenticationLevel read
        GetAuthenticationLevel write SetAuthenticationLevel;
    property CertStorage: TElMemoryCertStorage read GetCertStorage write
        SetCertStorage;
    property ClientAuthentication: boolean read GetClientAuthentication write
        SetClientAuthentication;
    property ClientCertStorage: TElCustomCertStorage read GetClientCertStorage
        write SetClientCertStorage;
    property ForceCertificateChain: boolean read GetForceCertificateChain write
        SetForceCertificateChain;
    property SessionPool: TElSessionPool read GetSessionPool write SetSessionPool;
    property Versions: TSBVersions read GetVersions write SetVersions;

    property OnCertificateURLs: TSBCertificateURLsEvent read FOnCertificateURLs
        write FOnCertificateURLs;
    property OnKeyNeeded: TSBServerKeyNeededEvent read FOnKeyNeeded write
        FOnKeyNeeded;
  end;

  TSSLServerRtcCryptPlugin = class(TSSLRtcCryptPlugin )
  protected
    FAuthenticationLevel: TSBAuthenticationLevel;

    FCertStorage: TElMemoryCertStorage;
    FClientCertStorage: TElCustomCertStorage;
    FSessionPool: TElSessionPool;
    FExtensions: TElServerSSLExtensions;
    FOnCertificateURLs: TSBCertificateURLsEvent;
    FOnKeyNeeded: TSBServerKeyNeededEvent;
    FClientAuthentication: boolean;

    function FindHandler(ConnID : TRtcConnID) : TSSLServerRtcHandler;
    function CreateHandler(ConnID : TRtcConnID): TSSLServerRtcHandler;

    procedure HandleCertificateURLs(Sender: TOBject; URLs : TElClientCertURLsSSLExtension;
      Certificates: TElMemoryCertStorage);
    procedure HandleKeyNeeded(Sender: TObject; const Identity : string; var Key :
        ByteArray);
    function GetCertStorage: TElMemoryCertStorage;
    function GetClientCertStorage: TElCustomCertStorage;
    function GetSessionPool: TElSessionPool;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure SetCertStorage(Value: TElMemoryCertStorage);
    procedure SetClientCertStorage(Value: TElCustomCertStorage);
    procedure SetSessionPool(Value: TElSessionPool);
  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;

    { Called after a new connection was established.
      OutData = data which has to be sent out immediately. }
    procedure AfterConnect(ID:TRtcConnID; var OutData:string); override;

    { Called before we do a graceful disconnect, in case some data has to be sent out. }
    procedure BeforeDisconnect(ID:TRtcConnID; var OutData:string); override;

    { Called after a connection was closed. }
    procedure AfterDisconnect(ID:TRtcConnID); override;

    { Called when data arrived.
      InData = data received from recipient (decode that!)
      OutData = data prepared by "decoder" for sending back to recipient (encoded data)
      OutPlainText = decrypted input data (for use by application) }
    procedure DataReceived(ID:TRtcConnID; const InData:string; var OutData:string; var OutPlainText:string); override;

    { Called when data needs to be sent.
      InData = application data which we want to be encoded for sending
      OutData = encoded data which should be sent out }
    procedure DataToSend(ID:TRtcConnID; const InData:string; var OutData:string); override;

    property Extensions: TElServerSSLExtensions read FExtensions;
  published
    property AuthenticationLevel : TSBAuthenticationLevel read
      FAuthenticationLevel write FAuthenticationLevel;
    property ClientAuthentication: boolean read FClientAuthentication write
      FClientAuthentication;
    property CertStorage: TElMemoryCertStorage read GetCertStorage
      write SetCertStorage;
    property ClientCertStorage: TElCustomCertStorage read GetClientCertStorage
    write SetClientCertStorage;
    property SessionPool: TElSessionPool read GetSessionPool write
      SetSessionPool;
    property ForceCertificateChain : boolean read FForceCertificateChain
      write FForceCertificateChain default false;

    property OnCertificateURLs: TSBCertificateURLsEvent read FOnCertificateURLs
        write FOnCertificateURLs;
    property OnKeyNeeded: TSBServerKeyNeededEvent read FOnKeyNeeded write
        FOnKeyNeeded;
  end;

procedure Register;

implementation


procedure Register;
begin
  RegisterComponents('SSLBlackbox', [TSSLServerRtcCryptPlugin]);
end;

{ TSSLServerRtcCryptPlugin }

procedure TSSLServerRtcCryptPlugin.AfterConnect(ID: TRtcConnID;
  var OutData: string);
var Handler : TSSLServerRtcHandler;
begin
  Handler := CreateHandler(ID);
  Handler.AfterConnect(OutData);
end;

procedure TSSLServerRtcCryptPlugin.AfterDisconnect(ID: TRtcConnID);
var Handler : TSSLServerRtcHandler;
begin
  Handler := FindHandler(ID);
  if Handler <> nil then
  begin
    FListGuard.Enter;
    Self.FConnList.Remove(Handler);
    FListGuard.Leave;
    Handler.AfterDisconnect;
    Handler.Free;
  end;
end;

procedure TSSLServerRtcCryptPlugin.BeforeDisconnect(ID: TRtcConnID;
  var OutData: string);
var Handler : TSSLServerRtcHandler;
begin
  Handler := FindHandler(ID);
  if Handler <> nil then
  begin
    Handler.BeforeDisconnect(OutData);
  end;
end;

constructor TSSLServerRtcCryptPlugin.Create(AOwner: TComponent);
begin
  inherited;

  FAuthenticationLevel := alRequireCert;
  FForceCertificateChain := false;

  FExtensions := TElServerSSLExtensions.Create;
  FExtensions.StrictCertRequest := false;
end;

procedure TSSLServerRtcCryptPlugin.DataReceived(ID: TRtcConnID;
  const InData: string; var OutData, OutPlainText: string);
var Handler : TSSLServerRtcHandler;
begin
  Handler := FindHandler(ID);
  if Handler <> nil then
  begin
    Handler.DataReceived(InData, OutData, OutPlainText);
  end;
end;

procedure TSSLServerRtcCryptPlugin.DataToSend(ID: TRtcConnID;
  const InData: string; var OutData: string);
var Handler : TSSLServerRtcHandler;
begin
  Handler := FindHandler(ID);
  if Handler <> nil then
  begin
    Handler.DataToSend(InData, OutData);
  end;
end;

destructor TSSLServerRtcCryptPlugin.Destroy;
begin
  CertStorage := nil;
  ClientCertStorage := nil;
  SessionPool := nil;
  FreeAndNil(FExtensions);
  FListGuard.Enter;
  try
    while FConnList.Count > 0 do
    begin
      TSSLServerRtcHandler(FConnList.Last).Free;
      FConnList.Delete(FConnList.Count - 1);
    end;
  finally
    FListGuard.Leave;
  end;
  inherited;
end;

function TSSLServerRtcCryptPlugin.FindHandler(ConnID: TRtcConnID): TSSLServerRtcHandler;
var i : integer;
begin
  result := nil;
  FListGuard.Enter;
  try
    for i := 0 to FConnList.Count - 1 do
    begin
      if TSSLServerRtcHandler(FConnList[i]).FConnID = ConnID then
      begin
        result := TSSLServerRtcHandler(FConnList[i]);
        exit;
      end;
    end;
  finally
    FListGuard.Leave;
  end;
end;

function TSSLServerRtcCryptPlugin.CreateHandler(ConnID : TRtcConnID):
    TSSLServerRtcHandler;
var i : integer;
begin
  Result := TSSLServerRtcHandler.Create;
  Result.FConnID := ConnID;
  FListGuard.Enter;
  FConnList.Add(Result);
  FListGuard.Leave;

  Result.CertStorage := FCertStorage;
  Result.ClientCertStorage := FClientCertStorage;
  Result.SessionPool := FSessionPool;
  Result.ClientAuthentication := FClientAuthentication;
  Result.AuthenticationLevel := FAuthenticationLevel;
  for I := SB_SUITE_FIRST to SB_SUITE_LAST do
    Result.CipherSuites[I] := FEnabledCipherSuites[I];
  for I := SSL_CA_FIRST to SSL_CA_LAST do
    Result.CompressionAlgorithms[I] := FCompressionAlgorithms[I];
  Result.Versions := FVersions;
  Result.ForceCertificateChain := FForceCertificateChain;

  Result.OnCertificateValidate := HandleCertificateValidate;
  Result.OnSSLEstablished := HandleSSLEstablished;
  Result.OnCiphersNegotiated := HandleCiphersNegotiated;
  Result.OnError := HandleError;
  Result.OnExtensionsReceived := HandleExtensionsReceived;

  Result.OnCertificateURLs := HandleCertificateURLs;
  Result.OnKeyNeeded := HandleKeyNeeded;

  Result.Extensions.Assign(Extensions);
  Result.PeerExtensions.Assign(PeerExtensions);

  Result.OnError := HandleError;
  Result.Open;
end;

function TSSLServerRtcCryptPlugin.GetCertStorage: TElMemoryCertStorage;
begin
  Result := FCertStorage;
end;

function TSSLServerRtcCryptPlugin.GetClientCertStorage: TElCustomCertStorage;
begin
  Result := FClientCertStorage;
end;

function TSSLServerRtcCryptPlugin.GetSessionPool: TElSessionPool;
begin
  Result := FSessionPool;
end;

procedure TSSLServerRtcCryptPlugin.HandleCertificateURLs(Sender: TOBject;
  URLs: TElClientCertURLsSSLExtension; Certificates: TElMemoryCertStorage);
begin
  if assigned(FOnCertificateURLs) then
    FOnCertificateURLs(Self, URLs, Certificates);
end;

procedure TSSLServerRtcCryptPlugin.HandleKeyNeeded(Sender: TObject; const
    Identity : string; var Key : ByteArray);
begin
  if Assigned(FOnKeyNeeded) then
    FOnKeyNeeded(Self, Identity, Key);
end;

procedure TSSLServerRtcCryptPlugin.Notification(AComponent: TComponent;
    Operation: TOperation);
begin
  inherited;
  if Operation = opRemove then
  begin
    if (AComponent = CertStorage) then
    begin
      SetCertStorage(nil);
    end
    else
      if (AComponent = SessionPool) then
      SetSessionPool(nil)
    else
      if (AComponent = ClientCertStorage) then
      SetClientCertStorage(nil);
  end;
end;

procedure TSSLServerRtcCryptPlugin.SetCertStorage(Value: TElMemoryCertStorage);
begin
  if Value <> FCertStorage then
  begin
    FCertStorage := Value;
    if Value <> nil then
      Value.FreeNotification(Self);
  end;
end;

procedure TSSLServerRtcCryptPlugin.SetClientCertStorage(Value:
    TElCustomCertStorage);
begin
  if Value <> FClientCertStorage then
  begin
    FClientCertStorage := Value;
    if Value <> nil then
      Value.FreeNotification(Self)
  end;
end;

procedure TSSLServerRtcCryptPlugin.SetSessionPool(Value: TElSessionPool);
begin
  if Value <> FSessionPool then
  begin
    FSessionPool := Value;
    if Value <> nil then
      Value.FreeNotification(Self)
  end;
end;

{ TSSLServerRtcHandler }

constructor TSSLServerRtcHandler.Create;
begin
  inherited;
  FSecureServer := TElSecureServer.Create(nil);
  FSecureServer.OnSend := HandleSend;
  FSecureServer.OnReceive := HandleReceive;
  FSecureServer.OnData := HandleData;
  FSecureServer.OnOpenConnection := HandleOpenConnection;
  FSecureServer.OnCloseConnection := HandleCloseConnection;
  FSecureServer.OnCertificateValidate := HandleCertificateValidate;
  FSecureServer.OnCiphersNegotiated := HandleCiphersNegotiated;
  FSecureServer.OnError := HandleError;
end;

destructor TSSLServerRtcHandler.Destroy;
begin
  inherited;
  FreeAndNil(FSecureServer);
end;

{ TSSLServerRtcCryptPlugin }

procedure TSSLServerRtcHandler.AfterConnect(var OutData: string);
begin
  FSecureServer.Open;
  if Length(FOutBuffer) > 0 then
  begin
    SetLength(OutData, Length(FOutBuffer));
    Move(FOutBuffer[0], OutData[1], Length(FOutBuffer));
    SetLength(FOutBuffer, 0);
  end;
end;

procedure TSSLServerRtcHandler.AfterDisconnect;
begin
end;

procedure TSSLServerRtcHandler.BeforeDisconnect(var OutData: string);
begin
  FSecureServer.Close;
  //Close;
  if Length(FOutBuffer) > 0 then
  begin
    SetLength(OutData, Length(FOutBuffer));
    Move(FOutBuffer[0], OutData[1], Length(FOutBuffer));
    SetLength(FOutBuffer, 0);
  end;
end;

procedure TSSLServerRtcHandler.Close;
var b : boolean;
begin
  b := FSecureServer.Enabled;
  FSecureServer.Enabled := false;
  FSecureServer.Close;
  FSecureServer.Enabled := b;
end;

procedure TSSLServerRtcHandler.DataReceived(const InData: string; var OutData,
    OutPlainText: string);
var OldSize : integer;
begin
  OutData := '';
  OutPlainText := '';

  if Length(InData) > 0 then
  begin
    // put incoming data
    OldSize := Length(FInBuffer);
    SetLength(FInBuffer, OldSize + Length(InData));
    Move(InData[1], FInBuffer[OldSize], Length(InData));

    // process the data
    while Length(FInBuffer) > 0 do
      FSecureServer.DataAvailable;
  end;

  // pick resulting data
  if Length(FOutBuffer) > 0 then
  begin
    SetLength(OutData, Length(FOutBuffer));
    Move(FOutBuffer[0], OutData[1], Length(FOutBuffer));
    SetLength(FOutBuffer, 0);
  end;

  // pick resulting data
  if Length(FDataBuffer) > 0 then
  begin
    SetLength(OutPlainText, Length(FDataBuffer));
    Move(FDataBuffer[0], OutPlainText[1], Length(FDataBuffer));
    SetLength(FDataBuffer, 0);
  end;

end;

procedure TSSLServerRtcHandler.DataToSend(const InData: string; var OutData:
    string);
begin
  OutData := '';

  if InData <> '' then
    FSecureServer.SendData(@InData[1], Length(InData));

  if Length(FOutBuffer) > 0 then
  begin
    SetLength(OutData, Length(FOutBuffer));
    Move(FOutBuffer[0], OutData[1], Length(FOutBuffer));
    SetLength(FOutBuffer, 0);
  end;
end;

function TSSLServerRtcHandler.GetAuthenticationLevel: TSBAuthenticationLevel;
begin
  Result := FSecureServer.AuthenticationLevel;
end;

function TSSLServerRtcHandler.GetCertStorage: TElMemoryCertStorage;
begin
  Result := FSecureServer.CertStorage;
end;

function TSSLServerRtcHandler.GetCipherSuite: TSBCipherSuite;
begin
  Result := FSecureServer.CipherSuite;
end;

function TSSLServerRtcHandler.GetCipherSuites(Index: TSBCipherSuite): boolean;
begin
  Result := FSecureServer.CipherSuites[Index];
end;

function TSSLServerRtcHandler.GetClientAuthentication: boolean;
begin
  Result := FSecureServer.ClientAuthentication;
end;

function TSSLServerRtcHandler.GetClientCertStorage: TElCustomCertStorage;
begin
  Result := FSecureServer.ClientCertStorage;
end;

function TSSLServerRtcHandler.GetCompressionAlgorithm:
    TSBSSLCompressionAlgorithm;
begin
  Result := FSecureServer.CompressionAlgorithm;
end;

function TSSLServerRtcHandler.GetCompressionAlgorithms(Index:
    TSBSSLCompressionAlgorithm): boolean;
begin
  Result := FSecureServer.CompressionAlgorithms[Index];
end;

function TSSLServerRtcHandler.GetExtensions: TElServerSSLExtensions;
begin
  Result := FSecureServer.Extensions;
end;

function TSSLServerRtcHandler.GetForceCertificateChain: boolean;
begin
  Result := FSecureServer.ForceCertificateChain;
end;

function TSSLServerRtcHandler.GetPeerExtensions: TElCustomSSLExtensions;
begin
  Result := FSecureServer.PeerExtensions;
end;

function TSSLServerRtcHandler.GetSessionPool: TElSessionPool;
begin
  Result := FSecureServer.SessionPool;
end;

function TSSLServerRtcHandler.GetVersion: TSBVersion;
begin
  Result := FSecureServer.CurrentVersion;
end;

function TSSLServerRtcHandler.GetVersions: TSBVersions;
begin
  Result := FSecureServer.Versions;
end;

procedure TSSLServerRtcHandler.HandleCloseConnection(Sender: TObject;
    CloseDescription: integer);
begin
  FConnected := false;
  FErrorOccured := true;
end;

procedure TSSLServerRtcHandler.HandleOpenConnection(Sender: TObject);
begin
  inherited;
  HandleSSLEstablished(Self, FSecureServer.CurrentVersion, FSecureServer.CipherSuite);
end;

procedure TSSLServerRtcHandler.InternalValidate(var Validity:
    TSBCertificateValidity; var Reason: TSBCertificateValidityReason);
begin
  FSecureServer.InternalValidate(Validity, Reason);
end;

procedure TSSLServerRtcHandler.Open;
begin
  inherited;
end;

procedure TSSLServerRtcHandler.SetAuthenticationLevel(Value:
    TSBAuthenticationLevel);
begin
  FSecureServer.AuthenticationLevel := Value;
end;

procedure TSSLServerRtcHandler.SetCertStorage(Value: TElMemoryCertStorage);
begin
  FSecureServer.CertStorage := Value;
end;

procedure TSSLServerRtcHandler.SetCipherSuites(Index: TSBCipherSuite; Value:
    boolean);
begin
  FSecureServer.CipherSuites[Index] := Value;
end;

procedure TSSLServerRtcHandler.SetClientAuthentication(Value: boolean);
begin
  FSecureServer.ClientAuthentication := Value;
end;

procedure TSSLServerRtcHandler.SetClientCertStorage(Value:
    TElCustomCertStorage);
begin
  FSecureServer.ClientCertStorage := Value;
end;

procedure TSSLServerRtcHandler.SetCompressionAlgorithms(Index:
    TSBSSLCompressionAlgorithm; Value: boolean);
begin
  FSecureServer.CompressionAlgorithms[Index] := Value;
end;

procedure TSSLServerRtcHandler.SetForceCertificateChain(Value: boolean);
begin
  FSecureServer.ForceCertificateChain := Value;
end;

procedure TSSLServerRtcHandler.SetSessionPool(Value: TElSessionPool);
begin
  FSecureServer.SessionPool := Value;
end;

procedure TSSLServerRtcHandler.SetVersions(Value: TSBVersions);
begin
  FSecureServer.Versions := Value;
end;

end.

