unit xmlrpcTest_unit;

interface

uses
  Windows, Messages, SysUtils,
  Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,

  rtcInfo;

type
  TForm1 = class(TForm)
    Panel3: TPanel;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel4: TPanel;
    Panel5: TPanel;
    eXMLSrc: TMemo;
    eXMLDest: TMemo;
    btnXML: TButton;
    Label1: TLabel;
    btnRequest: TButton;
    btnResponse: TButton;
    procedure btnXMLClick(Sender: TObject);
    procedure btnRequestClick(Sender: TObject);
    procedure btnResponseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnXMLClick(Sender: TObject);
  var
    obj:TRtcValue;
  begin
  if not isXMLString(eXMLSrc.Lines.Text) then
    raise Exception.Create('This is not a XML-RPC string!');

  obj:=TRtcValue.FromXMLrpc(eXMLSrc.Lines.Text);
  try
    eXMLDest.Lines.Clear;
    eXMLDest.Lines.Add('----- in XML-RPC format --------'#13#10);
    eXMLDest.Lines.Add(obj.toXMLrpc);
    eXMLDest.Lines.Add(#13#10#13#10+'----- in RTC format --------'#13#10);
    eXMLDest.Lines.Add(obj.toCode);
  finally
    obj.Free;
    end;
  end;

procedure TForm1.btnRequestClick(Sender: TObject);
  var
    obj:TRtcValue;
  begin
  if not isXMLString(eXMLSrc.Lines.Text) then
    raise Exception.Create('This is not a XML-RPC string!');

  obj:=TRtcValue.FromXMLrpc(eXMLSrc.Lines.Text);
  try
    eXMLDest.Lines.Clear;
    eXMLDest.Lines.Add('----- in XML-RPC format --------'#13#10);
    eXMLDest.Lines.Add(obj.toXMLrpcRequest);
    eXMLDest.Lines.Add(#13#10#13#10+'----- in RTC format --------'#13#10);
    eXMLDest.Lines.Add(obj.toCode);
  finally
    obj.Free;
    end;
  end;

procedure TForm1.btnResponseClick(Sender: TObject);
  var
    obj:TRtcValue;
  begin
  if not isXMLString(eXMLSrc.Lines.Text) then
    raise Exception.Create('This is not a XML-RPC string!');

  obj:=TRtcValue.FromXMLrpc(eXMLSrc.Lines.Text);
  try
    eXMLDest.Lines.Clear;
    eXMLDest.Lines.Add('----- in XML-RPC format --------'#13#10);
    eXMLDest.Lines.Add(obj.toXMLrpcResponse);
    eXMLDest.Lines.Add(#13#10#13#10+'----- in RTC format --------'#13#10);
    eXMLDest.Lines.Add(obj.toCode);
  finally
    obj.Free;
    end;
  end;

end.
